#ifndef AMAROK14DATAGETTER_H
#define AMAROK14DATAGETTER_H
#ifndef Q_WS_WIN

#include "trackmetainfo.h"
#include <QDebug>
#include <QObject>
#include <QProcess>
#include <QTimer>
#include <QSettings>

class Amarok14DataGetter : public QObject
{
Q_OBJECT
public:
    Amarok14DataGetter();
    ~Amarok14DataGetter();
    QString getURI();
    QString getArtist();
    QString getTitle();
    TrackMetaInfo getTrackMetaInfo();
private:
    QTimer* m_timer;
    QProcess* m_process_path;
    QProcess* m_process_artist;
    QProcess* m_process_title;
    QProcess* m_process_track;
    QProcess* m_process_album;
    QProcess* m_process_length;
    QSettings* m_data;
    TrackMetaInfo* m_meta_info;
private slots:
    void timeOut();
    void readPath();
    void readArtist();
    void readTitle();
    void readAlbum();
    void readTrack();
    void readLength();
};

#endif

#endif // AMAROK14DATAGETTER_H
