#ifndef SETTINGSUI_H
#define SETTINGSUI_H

#include "ui_settings.h"

#include <QWidget>
#include <QDebug>


class SettingsUI : public QWidget, public Ui::settingsUi{

Q_OBJECT

public:

        SettingsUI( QWidget * parent = 0, Qt::WFlags f = 0, QString profileName = "" );
        ~SettingsUI();
        void saveSettings();

private:

        QString m_profile_name;
        QStringList m_accounts;
        bool m_global_mode;
        QString m_player_name;
        int  m_timer_period;
        struct IcqAccountSettings{
            QString name;
            int status;
            QString message_mask_1;
            QString message_mask_2;
        };
        struct JabberAccountSettings{
            QString name;
            int status;
            QString message_mask;
        };
        struct MrimAccountSettings{
            QString name;
            int status;
            QString message_mask_1;
            QString message_mask_2;
            int mode;
        };
        struct GlobalSettings{
            int global;
            int icq_status;
            int jabber_status;
            int mrim_status;
            int mrim_mode;
            QString icq_message_mask_1;
            QString icq_message_mask_2;
            QString mrim_message_mask_1;
            QString mrim_message_mask_2;
            QString jabber_message;
        } m_global_settings;
        struct MPDSettings{
            QVariant hostname;
            int port;
            QVariant password;
        } m_mpd_settings;
        QList<IcqAccountSettings> m_icq_account_settings;
        QList<JabberAccountSettings> m_jabber_account_settings;
        QList<MrimAccountSettings> m_mrim_account_settings;
        int m_current_account_index;

        void loadSettings();
        void initFormValues();
        void setIcqSecondFieldDisabled();
        void setIcqThirdFieldDisabled();
        void setMrimSecondFieldDisabled();
        void setMrimThirdFieldDisabled();
        void setJabberSecondFieldDisabled();
        void setGlobalIcqSecondFieldDisabled();
        void setGlobalIcqThirdFieldDisabled();
        void setGlobalMrimSecondFieldDisabled();
        void setGlobalMrimThirdFieldDisabled();
        void setGlobalJabberSecondFieldDisabled();
        int getIndexByName(QString protocol_name, QString account);

private slots:

        void accountChanged(int index);
        void playerChanged(QString player);
        void setIcqSecondFieldEnabled(bool checked);
        void setIcqThirdFieldEnabled(bool checked);
        void setIcqAllFieldsDisabled(bool checked);
        void setJabberSecondFieldEnabled(bool checked);
        void setMrimSecondFieldEnabled(bool checked);
        void setMrimThirdFieldEnabled(bool checked);
        void setMrimAllFieldsDisabled(bool checked);
        void setGlobalIcqSecondFieldEnabled(bool checked);
        void setGlobalIcqThirdFieldEnabled(bool checked);
        void setGlobalIcqAllFieldsDisabled(bool checked);
        void setGlobalJabberSecondFieldEnabled(bool checked);
        void setGlobalMrimSecondFieldEnabled(bool checked);
        void setGlobalMrimThirdFieldEnabled(bool checked);
        void setGlobalMrimAllFieldsDisabled(bool checked);
        void globalModeStatusChanged();
        void changeGlobalStatus();

};

#endif





